import com.jniwrapper.*;
import com.jniwrapper.win32.FunctionName;
import com.jniwrapper.win32.Handle;
import com.jniwrapper.win32.io.FileSystemException;
import com.jniwrapper.win32.system.Kernel32;

import java.io.File;
import java.io.FileDescriptor;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Field;

public class Test {
    static final FunctionName FUNCTION_CREATE_FILE = new FunctionName("CreateFile");
    static final int FILE_LIST_DIRECTORY = 0x001;
    static final int FILE_DELETE_CHILD = 0x0040;
    static final int GENERIC_WRITE = 0x40000000;
    static final int FILE_ACCESS_MODE = GENERIC_WRITE;// | FILE_DELETE_CHILD;
    static final int FILE_SHARE_READ = 0x00000001;
    static final int FILE_SHARE_WRITE = 0x00000002;
    static final int FILE_SHARE_DELETE = 0x00000004;
    static final int OPEN_ALWAYS = 4;
    static final int FILE_ATTRIBUTE_NORMAL = 0x80;

    public static void main(String[] args) {

        String path = new File("test.txt").getAbsolutePath();
        Handle fileHandle = new Handle();
        final Function functionCreateFile = Kernel32.getInstance().getFunction(FUNCTION_CREATE_FILE.toString());
        functionCreateFile.invoke(fileHandle, new Parameter[]
                {
                        new Str(path),
                        new UInt32(FILE_ACCESS_MODE),
                        new UInt32(FILE_SHARE_DELETE | FILE_SHARE_READ | FILE_SHARE_WRITE),
                        new Pointer(null, true),
                        new UInt32(OPEN_ALWAYS),
                        new UInt32(FILE_ATTRIBUTE_NORMAL),
                        new Pointer(null, true)
                });
        final long handleValue = fileHandle.getValue();

        if (fileHandle.isNull() || handleValue == Handle.INVALID_HANDLE_VALUE)
            throw new FileSystemException("Could not open file " + path);

        FileDescriptor fd = new FileDescriptor();

        try {
            Class<FileDescriptor> descriptorClass = FileDescriptor.class;
            Field fdField = descriptorClass.getDeclaredField("handle");
            fdField.setAccessible(true);
            fdField.set(fd, (int)handleValue);

        } catch (NoSuchFieldException | IllegalAccessException e) {
            e.printStackTrace();
        }

        FileOutputStream fo = null;
        try {
            fo = new FileOutputStream(fd);
            fo.write("Hello world!".getBytes());
            fd.sync();
        } catch (IOException e) {
            e.printStackTrace();
        }
        finally {
            if(fo != null){
                try {
                    fo.flush();
                    fo.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

    }
}
